#include "defs.inc"
  ORG START_ADDR

#ifdef RK86
#ifdef SD_ROM
#else
  jmp 0f800H
  nop
#endif
#endif

ENTRY:
#ifdef MX2
  call 0c84eH  ;   
#endif
  lxi h,BUF
  lxi b,2048-256
clrmem:
  mvi m,0
  inx h
  dcx b
  mov a,c
  ora b
  jnz clrmem
  CALL FS_RST
LOOP:
;  LXI SP,066cf
  LXI H,A_DRIVE
  CALL PRINT
  LXI H,CWD
  CALL PRINT
  MVI C,'>'
  CALL PUTC
  CALL READLN
  LXI H,LOOP
  PUSH H
  LXI H,CMDLST
LOOP1:  MOV A,M
  ORA A
  JZ RUNFILE
  LXI D,LINEBUF
LOOP2:  MOV A,M
  ORA A
  JZ LOOP3
  LDAX D
  CMP M
  JNZ LOOP4
  INX D
  INX H
  JMP LOOP2
LOOP3:  LDAX D
  ORA A
  JZ LOOP5
  CPI 20H
  JZ LOOP5
LOOP4:  MOV A,M
  INX H
  ORA A
  JNZ LOOP4
  INX H
  INX H
  JMP LOOP1
LOOP5:  INX H
  MOV E,M
  INX H
  MOV D,M
  XCHG
  PCHL

PRINTN: MOV C,M
  INX H
  CALL PUTC
  DCR B
  JNZ PRINTN
  RET
  
C_DIR:  LXI H,NEWLINE
  CALL PRINT
  LXI H,LINEBUF+2
  INX H
  MOV A,M
  CPI 20H
  JZ $-4
  ORA A
  JNZ $+6
  LXI H,ALLFILS
  XCHG
  CALL FS_FNDF
  JC C_DIRNO
C_DIR1: PUSH H
  LXI B,11
  DAD B
  MOV A,M
  POP H
  ANI 8
  JNZ C_DIR2
  MVI B,8
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  MVI B,3
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  mov A,L
  adi 012H
  mov L,A
  mov A,M
  call 0F815H
  dcx H
  mov A,M
  call 0F815H
  LXI H,NEWLINE
  CALL PRINT
C_DIR2: CALL FS_FNDN
  JNC C_DIR1
  RET
C_DIRNO:LXI H,NOFILES
  JMP PRINT

C_CD: LXI H,LINEBUF+1
  INX H
  MOV A,M
  CPI 20H
  JZ $-4
  ORA A
  JNZ C_CD1
  LXI H,NEWLINE
  CALL PRINT
  LXI H,CWD
  JMP PRINT
C_CD1:  XCHG
  CALL FS_CHDIR
  RNC
  LXI H,NODIR
  JMP PRINT

C_X: 
;  lda 067feH
;  inr A
;  sta 067feH
;  mov B,A
;  CALL SD_PUT
;  mov a,b
;  call PRHEX
;  CALL SD_GET+3
;  call PRHEX
;  LXI H,NEWLINE
;  jmp PRINT
  CALL SD_OFF
#ifdef MX2
  JMP 0F800H
#endif
#ifdef STD
  JMP 0C800H
#endif
#ifdef RK86
  JMP 0F800H
#endif

C_RWR: 
  LXI H,NEWLINE
  CALL PRINT
  LXI H,LINEBUF+2
  XCHG
  CALL F_OPEN
  LXI H,NOFILES ;NOTFND
  JC PRINT

  LXI H,LINEBUF+2
C_RWR1: 
  INX H
  MOV A,M
  CPI 0
  JZ C_RWR2
  CPI 2CH
  JNZ C_RWR1
C_RWR2: 
  CALL R65
  LXI H,ERR
  JC PRINT
  LHLD LINEBUF+26  ;size 
  MOV  C,L  ;
  MOV  B,H  ;
  LHLD LINEBUF+24  ;   
  LXI D,LINEBUF
  LDAX D
   CPI 'R'
   JZ C_RWR3
  CALL F_WRITE
  JMP C_RWR4
C_RWR3: 
  CALL F_READ
C_RWR4: 
  LXI H,RWR_OK
  JMP PRINT

;**********************************************
;    
;**********************************************
R65:
    INX H
  XCHG
  LXI  H,0
  shld LINEBUF+24
  shld LINEBUF+26
;      LXI  D,LINEBUF ;R7B  ;
      CALL R7C 
  shld LINEBUF+24
;      SHLD R68 
;      SHLD R67 
      RC
      CALL R7C 
  shld LINEBUF+26
;      SHLD R67 
      RC
      ret
;*********************************************
;   16 
;*********************************************
R7C:  
      LXI  H,0 
R7F:  
      LDAX D
      INX  D
      CPI  00H
      JZ   R7E 
      CPI  2CH
      RZ
      CPI  20H
      JZ   R7F 
      SUI  30H
      JM   R79 
      CPI  0AH
      JM   R80 
      CPI  11H
      JM   R79 
      CPI  17H
      JP   R79 
      SUI  07H
R80:
      MOV  C,A
      DAD  H
      DAD  H
      DAD  H
      DAD  H
      JC   R79 
      DAD  B
      JMP  R7F 
R79:
  STC
R7E:
      RET
;**********************************************


RUNFILE:LXI H,NEWLINE
  CALL PRINT
  LXI H,LINEBUF
  MVI C,'.'
  CALL STRCHR
  JNC RUNF1
  LXI D,DOTRK
  CALL STRCPY
RUNF1:  LXI D,LINEBUF
  CALL F_OPEN
  LXI H,NOFILES ;NOTFND
  JC PRINT
  LXI B,4 ;   RK?    /           
  LXI H,LINEBUF
  CALL F_READ
  LXI H,LINEBUF
 ; MOV A,M ;     0E6H ????    ????
 ; CPI 0E6H
 ; JNZ RUNF2
 ; LXI B,1
 ; LXI H,LINEBUF+4
 ; CALL F_READ
 ; LXI H,LINEBUF+1
RUNF2:
  MOV e,M
  INX H
  MOV d,M
  INX H
  MOV c,M
  INX H
  MOV A,M
  SUB E
  MOV b,A
  MOV A,c
  SBB D
  MOV c,A
  INX B
  XCHG
  PUSH H ;  ,  ret  F_READ     
  CALL F_READ
     ;   
;  MVI  A, 1    ;  
;  LXI  B, BiosEntry  ;   SD BIOS -     sdbios  Vinxru
;  LXI  D, BUF  ;      -    !!!!!
;  LXI  H, BUF+256   ;      -    !!!!!
  RET

READLN: LXI H,LINEBUF
READL1: CALL GETC
  CPI 8
  JZ READL3
  CPI 5FH
  JZ READL3
  CPI 18H
  JZ READL4
  MVI M,0
  CPI 0DH
  RZ
  MOV M,A
  INX H
READL2: MOV C,A
  CALL PUTC
  JMP READL1
READL3: MOV A,L
  CPI LINEBUF & 255
  JZ READL1
  MVI C,8
  CALL PUTC
  MVI C,20H
  CALL PUTC
  MVI C,8
  CALL PUTC
  DCX H
  JMP READL1
READL4: MOV A,M
  ORA A
  JZ READL1
  CPI 0DH
  JZ READL1
  INX H
  JMP READL2

NEWLINE:DB 0DH,0AH,0
A_DRIVE:DB 0DH,0AH,"A:",0
RWR_OK: DB "OK",0
ERR:    DB "ERR",0
ALLFILS:DB "*",0
NOFILES:DB "NO FILE(S)",0
NODIR:  DB 0DH,0AH,"NO DIR",0
;NOTFND: DB "FILE NOT FOUND",0

#ifdef STD
DOTRK:  DB ".RKS",0
#endif

#ifdef MX2
DOTRK:  DB ".RKX",0
#endif

#ifdef RK86
DOTRK:  DB ".RKR",0
#endif

CMDLST: DB "DIR",0
        DW C_DIR
        DB "CD",0
        DW C_CD
        DB "X",0
        DW C_X
        DB "R",0
        DW C_RWR
        DB "W",0
        DW C_RWR
        DB 0

#include "sd_proc.inc"
#include "fs_proc.inc"

;EndProg              ;    -   
;#include "sd_bios.inc"  ;BiosEntry:
#ifdef RK86
 ORG START_ADDR+07ffH
  nop
#endif

#ifdef MX2
#include "sd_bios.inc"  ;BiosEntry:
#endif

  END
